
//Let's draw our stamina bar
hud.add(function(v,p)
	if not p.valid return end
	if not p.mo or not p.mo.valid return end
	if p.mo.skin ~= "dirfex" return end
	if p.dfx == nil return end 

	v.dirshihud   = v.cachePatch("DSHIRINGS")		//Ice hexagon above the stamina bar
	v.dirstambarL = v.cachePatch("DBARHUDL")		//Leftmost part of the stamina bar
	v.dirstambar  = v.cachePatch("DBARHUD")			//Middle part of the stamina bar
	v.dirstambarR = v.cachePatch("DBARHUDR")		//Rightmost part of the stamina bar

	//Local variables to more easily tweak bar positioning. Tweaked a bit for MRCE.
	local vertpos = hudinfo[HUD_LIVES].y - (p.mrce and 24 or 8)
	local barhori = 0
	local barcolor = p.dfx.noStam and SKINCOLOR_RED or SKINCOLOR_EMERALD
	local flash = nil
	if not (leveltime%4) and p.dfx.noStam then flash = TC_DASHMODE end

	//Ring requirement for the ice shield plus barrier cooldown and ice barrier icon in first person
	if p.dirringshi
		local hudtrans = V_HUDTRANS
		if p.dfx.barriercooldown then hudtrans = V_HUDTRANSHALF end
		v.draw(hudinfo[HUD_LIVES].x + 5, vertpos - 20, v.dirshihud, hudinfo[HUD_LIVES].f|hudtrans|V_PERPLAYER)
		v.drawString(hudinfo[HUD_LIVES].x + 14, vertpos - 15, p.dirringshi, hudinfo[HUD_LIVES].f|hudtrans|V_PERPLAYER|V_SKYMAP, "center")
		if p.dfx.barriercooldown //Yes I know it's repeated shut up
			v.drawString(hudinfo[HUD_LIVES].x + 14, vertpos - 23, p.dfx.barriercooldown/TICRATE, hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER|V_REDMAP, "center")
		end
		
		//We entered first person mode, so let's make our ice barrier invisible and create a HUD icon for it
		if p.dfx.icebarrier and not camera.chase

			//Cache our icon, then draw it alongsides the ice hexagon
			v.dirbarricon = v.cachePatch("TVIBICON")
			v.drawScaled((hudinfo[HUD_LIVES].x + 35) * FRACUNIT,
						 (vertpos - 19) * FRACUNIT,
						 FRACUNIT/2,
						 v.dirbarricon, hudinfo[HUD_LIVES].f|hudtrans|V_PERPLAYER
			)
		end
	end

	//Left bit of our stamina bar
	v.draw(hudinfo[HUD_LIVES].x + barhori, vertpos, v.dirstambarL, hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER, v.getColormap(flash, barcolor))

	//The stamina bar itself, which is rescaled as it decreases
	local hscale = p.dfx.stamina * (FRACUNIT/100) //Horizontal scale of our bar
	v.drawStretched(
				 (hudinfo[HUD_LIVES].x + barhori + 6) * FRACUNIT, 
				 (vertpos) * FRACUNIT,
				 hscale,
				 FRACUNIT,
				 v.dirstambar, 
				 hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER,
				 v.getColormap(flash, barcolor)
	)

	//Right bit of our stamina bar, which isn't scaled but uses the non-pixel perfect scaling to move to the left
	local xshift = (55*FRACUNIT / 100) * p.dfx.stamina
	v.drawScaled((hudinfo[HUD_LIVES].x + barhori + 5) * FRACUNIT + xshift,
				 (vertpos) * FRACUNIT, FRACUNIT, v.dirstambarR, hudinfo[HUD_LIVES].f|V_HUDTRANS|V_PERPLAYER, v.getColormap(flash, barcolor))

end,"game")