
//Freeslotting
freeslot("MT_DSHI", "MT_DSNO", "MT_DSTOMPRING", "MT_DBRIPART", "MT_DICESPIKE",
"MT_ICESHATTER", "MT_DICESHIELD", "MT_DWIN",

"S_DRIP", "S_PLAY_DIRDASH", "S_PLAY_DIRJUDASH", "S_PLAY_DIRSPINSTOMP",
"S_PLAY_DIRCARRY", "S_DIRSHI", "S_DIRFLAK", "S_DIRFLAKST", "S_DSTOMPRING",
"S_DBRIPART", "S_DICESPIKE", "S_ICESHATTER", "S_DICESHIELD", "S_DWIN",

"SPR2_DSEG", "SPR2_DRIP", "SPR2_DDAS", "SPR2_DIRU", "SPR_FLAK", "SPR_DISR",
"SPR_DBRI", "SPR_DORF", "SPR_DSHI", "SPR_DSPI", "SPR_DICR", "SPR_DESC", 
"SPR_DWIN",

"SFX_DBRI", "SFX_DUIN", "SFX_DTIR", "SFX_MADRU")

	// ------------------------------------------------------------ //

//Captioning
sfxinfo[sfx_s23b].caption = "Dashing"
sfxinfo[sfx_s23c].caption = "Jump dash"
sfxinfo[sfx_kc40].caption = "Powerful impact"
sfxinfo[sfx_dtir].caption = "Tired dashing"
sfxinfo[sfx_dbri].caption = "Creating ice"
sfxinfo[sfx_duin].caption = "Ultra instinct"
sfxinfo[sfx_madru].caption = "NO!"

	// ------------------------------------------------------------ //

//Mobj
mobjinfo[MT_DSHI] = { //Dash ice shield
	spawnstate = S_DIRSHI,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY
}

mobjinfo[MT_DSNO] = { //Dash ice particle
	spawnstate = S_DIRFLAK,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY
}

mobjinfo[MT_DSTOMPRING] = { //Impact ring around stomp area
	spawnstate = S_DSTOMPRING,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SCENERY|MF_NOGRAVITY
}

mobjinfo[MT_DBRIPART] = { //Hexagonal ice bridge
	spawnstate = S_DBRIPART,
	radius = 46*FRACUNIT,
	height = 1*FRACUNIT,
	flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SCENERY
}

mobjinfo[MT_DICESPIKE] = { //Ice spikes
	spawnstate = S_DICESPIKE,
	radius = 12*FRACUNIT,
	height = 16*FRACUNIT
}

mobjinfo[MT_ICESHATTER] = { //Shattered ice crystals
	spawnstate = S_ICESHATTER,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_NOBLOCKMAP|MF_SCENERY
}

mobjinfo[MT_DICESHIELD] = { //Orbiting ice shield
	spawnstate = S_DICESHIELD,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_SCENERY|MF_NOGRAVITY
}

mobjinfo[MT_DWIN] = { //Wind particles
	spawnstate = S_DWIN,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOCLIPTHING|MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY
}

	// ------------------------------------------------------------ //

//States
states[S_DRIP] = { //Drip state
	sprite = SPR_PLAY,
	frame = SPR2_DRIP,
	tics = -1,
	nextstate = S_DRIP,
}

states[S_PLAY_DIRDASH] = { //Dash state
	sprite = SPR_PLAY,
	frame = FF_ANIMATE|SPR2_DIRU,
	tics = -1,
	var1 = 4,
    var2 = 2,
	nextstate = S_PLAY_DIRDASH,
}

states[S_PLAY_DIRJUDASH] = { //Jump dash state
	sprite = SPR_PLAY,
	frame = SPR2_DDAS,
	tics = -1,
	nextstate = S_PLAY_DIRJUDASH,
}

states[S_PLAY_DIRSPINSTOMP] = { //Spin stomp state
	sprite = SPR_PLAY,
	frame = SPR2_ROLL|FF_ANIMATE,
	tics = -1,
	var1 = 2,
	var2 = 1,
	nextstate = S_PLAY_DIRSPINSTOMP,
}

states[S_PLAY_DIRCARRY] = { //Carrying state
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	tics = -1,
	nextstate = S_PLAY_DIRCARRY,
}

states[S_DIRSHI] = { //Dash ice shield's spawn state
	sprite = SPR_DSHI,
	frame = FF_TRANS30|FF_PAPERSPRITE|A,
	tics = -1,
	nextstate = S_DIRSHI,
}

states[S_DIRFLAK] = { //Dash ice particle starting anim
	sprite = SPR_FLAK,
	frame = FF_TRANS10|FF_ANIMATE|A,
	tics = 5,
	var1 = 5,
    var2 = 1,
	nextstate = S_DIRFLAKST,
}

states[S_DIRFLAKST] = { //Dash ice particle final frame
	sprite = SPR_FLAK,
	frame = FF_TRANS10|F,
	tics = -1,
	nextstate = S_DIRFLAKST,
}

states[S_DSTOMPRING] = { //Stomp ring single tic state
	sprite = SPR_DISR,
	frame = A,
	tics = 10,
	nextstate = S_NULL,
}

states[S_DBRIPART] = { //One part of dirfex's ice bridge
	sprite = SPR_DBRI,
	frame = FF_FLOORSPRITE|A,
	tics = -1,
	nextstate = S_DBRIPART,
}

states[S_DICESPIKE] = { //Ice spikes individual state
	sprite = SPR_DSPI,
	frame = FF_TRANS10|A,
	tics = 70,
	nextstate = S_NULL,
}

states[S_ICESHATTER] = { //Shattered ice pieces
	sprite = SPR_DICR,
	frame = FF_TRANS30|A,
	tics = 90,
	nextstate = S_NULL,
}

states[S_DICESHIELD] = { //Orbiting ice shield state
	sprite = SPR_DESC,
	frame = FF_TRANS40|FF_PAPERSPRITE|A,
	tics = -1,
	nextstate = S_DICESHIELD,
}

states[S_DWIN] = { //Wind particles
	sprite = SPR_DWIN,
	frame = FF_PAPERSPRITE|FF_ANIMATE|A,
	tics = 14,
	var1 = 14,
	var2 = 2,
	nextstate = S_NULL,
}